#import "CustomPanel.h"
#import <AppKit/AppKit.h>

@implementation CustomPanel

- (id)initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)aStyle backing:(NSBackingStoreType)bufferingType defer:(BOOL)flag {
    int mask = NSTitledWindowMask;
    mask |= NSClosableWindowMask;
    mask |= NSMiniaturizableWindowMask;
    mask |= NSUtilityWindowMask;
    NSWindow* result = [super initWithContentRect:contentRect styleMask:mask backing:NSBackingStoreBuffered defer:NO];
    [result setBackgroundColor:[NSColor clearColor]];
    [result setAlphaValue:1.0];
    [result setOpaque:NO];
    [result setHasShadow:NO];
    return result;
}

- (BOOL) canBecomeKeyWindow {
    return YES;
}

- (BOOL) canBecomeMainWindow {
    return NO;
}

@end
