property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "iTMS Estimator"
property script_version : "1.1.2"
property script_release_date : date "Tuesday, February 7, 2006 2:00:00 PM"
property script_copyright : (" 2005, " & ((year of script_release_date) as Unicode text) & " " & script_author & ". All Rights Reserved.")

property script_url : "http://homepage.mac.com/jonn8/as/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20iTMS%20Estimator%20(v" & script_version & ")"
property script_contribution_url : "https://order.kagi.com/?ELJ"
property detail_string : ""
property date_0 : ""
property date_1 : ""
property count_0 : ""
property count_1 : ""
property target_count : 0
property buy_time : 0
property per_second_sales : 0
property last_check : ""
property time_to_GMT : 0
property milestone_unit : 100000
property localized_unit_delim : ""
property counter_xml_URL : "http://www.apple.com/itunes/itms_counter.xml" --"http://www.apple.com/itunes/external_counter.xml"

property first_run : true
property run_plead : true
property rate_adjustment : 0.8
property update_frequency : 5
property use_beep : true
property the_level : 2
property the_setting_names : {"first_run", "run_plead", "rate_adjustment", "update_frequency", "use_beep", "the_level"}
property the_levels : {"kCGDesktopWindowLevel", "NSNormalWindowLevel", "NSScreenSaverWindowLevel"}

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
	set detail_string to my localized_string("label2")
	set localized_unit_delim to my localized_string("unit delimiter")
	set time_to_GMT to time to GMT
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run = true then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		my adjust_level()
		tell the_object
			if first_run then center
			set string value of text field "label1" to my localized_string("label1")
			set string value of text field "label1_shadow" to my localized_string("label1")
		end tell
		my get_estimate()
		
	else if object_name = "prefs" then
		tell the_object
			set float value of slider "rate_adjustment" to rate_adjustment
			set string value of text field "rate_adjustment" to ((round of (100 * rate_adjustment)) & "%") as Unicode text
			set integer value of slider "update_frequency" to update_frequency
			set state of button "use_beep" to (use_beep as integer)
			tell popup button "the_level"
				set the_titles to title of menu items of menu of it
				set title to item the_level of the_titles
			end tell
		end tell
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & ((month of script_release_date) as Unicode text) & " " & ((day of script_release_date) as Unicode text) & ", " & ((year of script_release_date) as Unicode text))
				set contents of text field "copyright" to script_copyright
				set state of button "run_plead" to run_plead as integer
			end tell
		end tell
		
	end if
end awake from nib

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	else if object_name = "prefs" then
		display window "prefs" attached to window "main"
		
	else if object_name = "get_estimate" then
		my get_estimate()
		
	else if object_name = "the_level" then
		set the_titles to title of menu items of menu of the_object
		set current_title to title of the_object
		repeat with i from 1 to (count the_titles)
			if the_titles's item i = current_title then exit repeat
		end repeat
		set the_level to i
		my adjust_level()
		
	end if
end choose menu item

on adjust_level()
	call method "setWindowLevel:useLevel:" of class "methods" with parameters {window "main", item the_level of the_levels}
end adjust_level

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	try
		set true_or_false to state of the_object as boolean
	end try
	
	if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "contribute" then
		open location script_contribution_url
		
	else if object_name = "run_plead" then
		set run_plead to true_or_false
		
	else if object_name = "use_beep" then
		set use_beep to true_or_false
		
	else if object_name = "get_estimate" then
		my get_estimate()
		
	end if
end clicked

on will open the_object
	return true
end will open

on will quit the_object
	my quit_prep()
	return true
end will quit

on idle the_object
	my update_estimate()
	return 1
end idle

on action the_object
	set object_name to name of the_object as Unicode text
	if object_name = "rate_adjustment" then
		set rate_adjustment to float value of the_object
		set string value of text field "rate_adjustment" of window "prefs" to ((round of (100 * rate_adjustment)) & "%") as Unicode text
		my get_estimate()
		
	else if object_name = "update_frequency" then
		set update_frequency to integer value of the_object
		
	end if
end action

on close_all_panels()
	try
		set the_panels to windows whose class = panel and visible = true
		repeat with this_panel in the_panels
			try
				if name of this_panel  "main" then close panel this_panel
			on error
				close panel this_panel
			end try
		end repeat
	end try
end close_all_panels

on quit_prep()
	my close_all_panels()
	my write_settings()
	if run_plead then my plead()
	set quitting to true
end quit_prep

on display_error(the_title, the_error)
	activate
	beep
	my update_status("Error: " & the_error)
	display alert the_title as critical message the_error default button my localized_string("OK") attached to window "main"
end display_error

on assign_settings(the_settings)
	set {first_run, run_plead, rate_adjustment, update_frequency, use_beep, the_level} to the_settings
end assign_settings

on get_settings()
	return {first_run, run_plead, rate_adjustment, update_frequency, use_beep, the_level}
end get_settings

on register_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				make new default entry at end of default entries with properties {name:(item i of the_setting_names), contents:(item i of the_settings)}
			end try
		end repeat
		register
	end tell
end register_settings

on read_settings()
	set the_settings to {}
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set end of the_settings to contents of default entry (item i of the_setting_names)
			end try
		end repeat
	end tell
	my assign_settings(the_settings)
end read_settings

on write_settings()
	set the_settings to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_setting_names)
			try
				set contents of default entry (item i of the_setting_names) to (item i of the_settings)
			end try
		end repeat
	end tell
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status

on plead()
	tell application "System Events"
		activate
		set the_button to button returned of (display dialog my localized_string("plead") buttons {my localized_string("Maybe Later"), my localized_string("Contribute Now")} default button 2 with icon 1)
		if the_button = my localized_string("Contribute Now") then open location script_contribution_url
	end tell
end plead

on update_estimate()
	try
		set current_date to current date
		set the_increment to ((current_date - date_1) * per_second_sales)
		set counter to round of (count_1 + the_increment) rounding up
		if (counter > target_count) or ((current_date - last_check)  (update_frequency * 60)) then my get_estimate() --adjust estimate every 5 minutes or when the target has passed...
		if (buy_time - current_date  10) and use_beep then beep --beep when you have 10 seconds to the estimated buy time...
		set counter to my number_to_string(counter, localized_unit_delim)
		tell window "main"
			set string value of text field "counter" to counter
			set string value of text field "counter_shadow" to counter
		end tell
	end try
end update_estimate

on get_estimate()
	try
		tell progress indicator 1 of window "main" to start
		set current_date to current date
		set last_check to current_date
		set the_xml to do shell script "curl " & counter_xml_URL
		set {data_0, data_1} to {my string_to_list(the_xml's paragraph 4, "\""), my string_to_list(the_xml's paragraph 3, "\"")}
		set {date_0, date_1} to {(date (data_0's item 4)) + time_to_GMT, (date (data_1's item 4)) + time_to_GMT}
		set {count_0, count_1} to {data_0's item 5's word 2 as integer, data_1's item 5's word 2 as integer}
		set {per_second_sales, next_target} to {((count_1 - count_0) / (date_1 - date_0)) * rate_adjustment, 0}
		repeat
			set target_count to ((round of (count_1 / milestone_unit) rounding up) * milestone_unit) + next_target
			set buy_time to date_1 + ((target_count - count_1) / per_second_sales)
			if buy_time > current_date then exit repeat
			set next_target to next_target + milestone_unit
		end repeat
		set this_detail_string to my snr(detail_string, "%1", my number_to_string(target_count, localized_unit_delim))
		set this_detail_string to my snr(this_detail_string, "%2", buy_time as Unicode text)
	on error e
		my display_error(my localized_string("Error"), e)
		set this_detail_string to my localized_string("retreive error")
	end try
	tell window "main"
		tell progress indicator 1 to stop
		set string value of text field "label2" to this_detail_string
		set string value of text field "label2_shadow" to this_detail_string
	end tell
end get_estimate

on string_to_list(s, d)
	tell (a reference to my text item delimiters)
		set {o, contents} to {contents, d}
		set {s, contents} to {s's text items, o}
	end tell
	return s
end string_to_list

on number_to_string(the_number, unit_delimiter)
	set the_number to the_number as Unicode text
	if the_number contains "E+" then
		set old_tid to my get_tid()
		my set_tid("E+")
		try
			set {basic_real, powers_of_ten} to {the_number's text item 1, (the_number's text item 2) as integer}
		on error
			my set_tid("e+")
			set {basic_real, powers_of_ten} to {the_number's text item 1, (the_number's text item 2) as integer}
		end try
		my set_tid(".")
		try
			set {integer_part, decimal_part} to basic_real's {text item 1, text item 2}
			set decimal_sign to "."
		on error
			my set_tid(",")
			set {integer_part, decimal_part} to basic_real's {text item 1, text item 2}
			set decimal_sign to ","
		end try
		my set_tid(old_tid)
		set n to count decimal_part
		if powers_of_ten  n then
			repeat (powers_of_ten - n) times
				set decimal_part to decimal_part & "0"
			end repeat
			set the_number to integer_part & decimal_part
		else
			set the_number to integer_part & decimal_part
			set the_number to (the_number's text 1 thru (powers_of_ten + 1)) & decimal_sign & (the_number's text (powers_of_ten + 2) thru -1)
		end if
	end if
	if unit_delimiter is not in {"", missing value} then
		set char_count to count the_number
		if char_count > 4 then
			set this_section to char_count
			repeat while this_section > 3
				set the_number to the_number's text 1 thru (this_section - 3) & unit_delimiter & the_number's text (this_section - 2) thru -1
				set this_section to this_section - 3
			end repeat
		end if
	end if
	return the_number
end number_to_string

on set_tid(the_delim)
	set my text item delimiters to the_delim
end set_tid

on get_tid()
	return my text item delimiters
end get_tid

on snr(the_string, search_string, replace_string)
	tell (a reference to my text item delimiters)
		set {old_tid, contents} to {contents, search_string}
		set {the_string, contents} to {the_string's text items, replace_string}
		set {the_string, contents} to {the_string as Unicode text, old_tid}
	end tell
	return the_string
end snr

on localized_string(i)
	return localized string i from table "localizable"
end localized_string