#import <Cocoa/Cocoa.h>

@interface methods : NSObject
+ (void)setWindowLevel:(NSWindow *)theWindow useLevel:(NSString *)theLevel;
@end

@implementation methods

+ (void)setWindowLevel:(NSWindow *)theWindow useLevel:(NSString *)theLevel {
    if ([theLevel isEqualToString:@"NSNormalWindowLevel"]) {
	[theWindow setLevel:NSNormalWindowLevel]; 
    } else if ([theLevel isEqualToString:@"NSFloatingWindowLevel"]) {	
	[theWindow setLevel:NSFloatingWindowLevel]; // Useful for floating palettes.
    } else if ([theLevel isEqualToString:@"NSSubmenuWindowLevel"]) {	
	[theWindow setLevel:NSSubmenuWindowLevel]; // Reserved for submenus. Synonymous with NSTornOffMenuWindowLevel, which is preferred.
    } else if ([theLevel isEqualToString:@"NSTornOffMenuWindowLevel"]) {	
	[theWindow setLevel:NSTornOffMenuWindowLevel]; // The level for a torn-off menu. Synonymous with NSSubmenuWindowLevel.
    } else if ([theLevel isEqualToString:@"NSMainMenuWindowLevel"]) {	
	[theWindow setLevel:NSMainMenuWindowLevel]; // Reserved for the application's main menu.
    } else if ([theLevel isEqualToString:@"NSStatusWindowLevel"]) {	
	[theWindow setLevel:NSStatusWindowLevel]; // The level for a status window.	
    } else if ([theLevel isEqualToString:@"NSPopUpMenuWindowLevel"]) {	
	[theWindow setLevel:NSPopUpMenuWindowLevel]; // The level for a pop-up menu.
    } else if ([theLevel isEqualToString:@"NSScreenSaverWindowLevel"]) {	
	[theWindow setLevel:NSScreenSaverWindowLevel]; // The level for a screen saver.
    } else if ([theLevel isEqualToString:@"kCGDesktopWindowLevel"]) {	
	[theWindow setLevel:kCGDesktopWindowLevel]; // Desktop level behind Finder icons.
    }
}

@end
