/*

Copyright (c) 2005, Jonathan Nathan. All Rights Reserved.

*/

var path = "";
var detail_string = "";
var date_0 = 0;
var date_1 = 0;
var count_0 = 0;
var count_1 = 0;
var target_count = 0;
var buy_time = 0;
var per_second_sales = 0;
var last_check = 0;
var time_to_GMT = 0;
var milestone_unit = 100000;
var localized_unit_delim = ",";
var rateAdjustmentVal = 8;
var updateFrequencyVal = 5;
var useBeepVal = true;
var timer = null;

function setup() {
	if (!(widget.preferenceForKey("useBeepVal") == undefined)) {
		rateAdjustmentVal = widget.preferenceForKey("rateAdjustmentVal");
		updateFrequencyVal = widget.preferenceForKey("updateFrequencyVal");
		useBeepVal = widget.preferenceForKey("useBeepVal");
	}	
	setRateAdjustment();
	setUpdateFrequency();
	setUseBeep();

	path = getLocalizedString('path');
	detail_string = getLocalizedString('bottom');
	localized_unit_delim = getLocalizedString('unitDelim');
    document.getElementById('top').innerText = getLocalizedString('top');
    document.getElementById('shop').innerText = getLocalizedString('shop');
    document.getElementById('prefLabel0').innerText = getLocalizedString('prefLabel0');
    document.getElementById('prefLabel1').innerText = getLocalizedString('prefLabel1');
    document.getElementById('prefLabel2').innerText = getLocalizedString('prefLabel2');

	createGenericButton(document.getElementById('done'), getLocalizedString('done'), hidePrefs);
    document.getElementById('emailImg').innerHTML = '<img src="' + path + 'email.png" alt="email" width="15" height="15" />';
    document.getElementById('contributeImg').innerHTML = '<img src="' + path + 'contribute.png" alt="contribute" width="15" height="15" />';
    document.getElementById('shopImg').innerHTML = '<img src="' + path + 'shop_now.png" alt="shop" width="15" height="15" />';

	getEstimate();
	updateEstimate();
}

if (window.widget) {
	widget.onshow = onshow;
	widget.onhide = onhide;
	widget.onremove = onremove;
}


function onshow() {
    if (timer == null) {
 		updateEstimate();
		timer = setInterval("updateEstimate();", 100);
	}
}

function onhide() {
    if (timer != null) {
		clearInterval(timer);
		timer = null;
    }
}

function onremove() {
	if (updateInterval != null) {
		clearInterval(updateInterval);
		updateInterval = null;
	}
}

function endBeep() {
}

function updateEstimate() {
	var current_date = new Date();
	var the_increment = parseInt(((current_date.valueOf() - date_1.valueOf()) / 1000) * per_second_sales); //Math.ceil
	var counter = parseInt(count_1) + the_increment;
	var time_left = (buy_time.valueOf() - current_date.valueOf());
	if ((counter >= target_count) || ((current_date.valueOf() - last_check.valueOf()) >= (updateFrequencyVal * 60000)) || (time_left <= 0)) {
		getEstimate();
	} else if ((time_left <= 10000) && useBeepVal) {
		if (((parseInt(time_left / 100)) % 10) == 0) {
			var command = widget.system("/usr/bin/osascript -e 'beep'", endBeep);
			command.close()
		}
	}
	document.getElementById('counter').innerText = intDelim(Math.ceil(counter));
}

function getEstimate() {
	var next_target = 0;
	var this_detail_string = detail_string;
	var current_date = new Date();
	last_check = current_date;
	var req = new XMLHttpRequest();
	req.open("GET", "http://www.apple.com/itunes/itms_counter.xml", false);
	req.setRequestHeader('If-Modified-Since','Wed, 15 Nov 1995 00:00:00 GMT');
	req.send(null);
	count_0 = parseInt(req.responseXML.getElementsByTagName('count')[1].childNodes[0].nodeValue);
	count_1 = parseInt(req.responseXML.getElementsByTagName('count')[0].childNodes[0].nodeValue);
	date_0 = new Date(req.responseXML.getElementsByTagName('count')[1].getAttribute('timestamp'));
	date_1 = new Date(req.responseXML.getElementsByTagName('count')[0].getAttribute('timestamp'));
	per_second_sales = (count_1 - count_0) / (date_1.valueOf() - date_0.valueOf());
	per_second_sales = (per_second_sales * (parseInt(100 * rateAdjustmentVal)));

	buy_time = current_date;	
	while (buy_time.valueOf() <= current_date.valueOf()) {
		target_count = ((Math.ceil(count_1 / milestone_unit)) * milestone_unit) + next_target;
		buy_time = new Date(date_1.valueOf() + (parseInt(((target_count - count_1) / per_second_sales) * 1000)));
		next_target += milestone_unit;
	}
	this_detail_string = snr(this_detail_string, "%1", intDelim(target_count));
	this_detail_string = snr(this_detail_string, "%2", buy_time.toLocaleString());
	document.getElementById('bottom').innerHTML = this_detail_string;
}

function saveSettings() {
	if (window.widget) {
		widget.setPreferenceForKey(rateAdjustmentVal, "rateAdjustmentVal");
		widget.setPreferenceForKey(updateFrequencyVal, "updateFrequencyVal");
		widget.setPreferenceForKey(useBeepVal, "useBeepVal");
	}
}

function onremove() {
	saveSettings();
}

function setRateAdjustment() {
    var elem = document.getElementById('rateAdjustment');
	elem.selectedIndex = (10 - rateAdjustmentVal);
}

function changeRateAdjustment(elem) {
	rateAdjustmentVal = parseInt(elem.options[elem.selectedIndex].value);
	widget.setPreferenceForKey(rateAdjustmentVal,"rateAdjustmentVal");
	getEstimate();
}

function setUpdateFrequency() {
    var elem = document.getElementById('updateFrequency');
    var selectedIndex;
	switch(parseInt(updateFrequencyVal)) {
		case 1:
			selectedIndex = 0;
			break;
		case 2:
			selectedIndex = 1;
			break;
		case 5:
			selectedIndex = 2;
			break;
		case 10:
			selectedIndex = 3;
			break;
		case 15:
			selectedIndex = 4;
			break;
		case 30:
			selectedIndex = 5;
			break;
	}
	elem.selectedIndex = selectedIndex;
}

function changeUpdateFrequency(elem) {
	switch(parseInt(elem.options[elem.selectedIndex].value)) {
		case 1:
			if(window.widget) {
				updateFrequencyVal = 1;
			}
			break;
		case 2:
			if(window.widget) {
				updateFrequencyVal = 2;
			}
			break;
		case 3:
			if(window.widget) {
				updateFrequencyVal = 5;
			}
			break;
		case 4:
			if(window.widget) {
				updateFrequencyVal = 10;
			}
			break;
		case 5:
			if(window.widget) {
				updateFrequencyVal = 15;
			}
			break;
		case 6:
			if(window.widget) {
				updateFrequencyVal = 30;
			}
			break;
	}
	widget.setPreferenceForKey(updateFrequencyVal,"updateFrequencyVal");
}

function setUseBeep() {
    var elem = document.getElementById('useBeep');
    var selectedIndex;
	switch(useBeepVal) {
		case true:
			selectedIndex = 0;
			break;
		case false:
			selectedIndex = 1;
			break;
	}
	elem.selectedIndex = selectedIndex;
}

function changeUseBeep(elem) {
	switch(parseInt(elem.options[elem.selectedIndex].value)) {
		case 1:
			if(window.widget) {
				useBeepVal = true;
			}
			break;
		case 2:
			if(window.widget) {
				useBeepVal = false;
			}
			break;
	}
	widget.setPreferenceForKey(useBeepVal,"useBeepVal");
}

function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	front.style.display="block";
	back.style.display="none";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event) {
	if (flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function getLocalizedString(key) {
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

function snr(the_string, search_string, replace_string) { 
   var sVal; 
   try { 
      sVal = new String(the_string); 
      if (sVal.length < 1) { return sVal; } 
      var sRegExp = eval("/" + search_string + "/g"); 
      sVal = sVal.replace(sRegExp, replace_string); 
   } 
   catch (exception)  { } 
   return sVal; 
} 

function intDelim(num) {
    var T = "", S = String(num), L = S.length - 1, C, j, P = S.indexOf(".") - 1;
    if (P < 0) {P = L;}
    for (j = 0; j <= L; j++) {
        T += (C = S.charAt(j));
        if ((j < P) && ((P - j) % 3 == 0) && (C != "-")) {T += localized_unit_delim;}
    }
    return T;
}
